<?php

CLASS Cabang extends RasioProject
{
	protected $set;
	protected $enableCk = true;

	public function __construct($config)
	{
		$this->getConfig($config);
		$this->validation();
		$this->set();
	}

	protected function set()
	{
		$this->set->em 			= $this->em;
		$this->set->modul 		= 'Profit Center';
		$this->set->dBaseH 		= 'cabang';
		$this->set->dBaseD 		= false;
		$this->set->dBasePk 	= array('kd_cabang');
		$this->set->dSort 		= 'asc';
		$this->set->form 		= $this->setForm();
		$this->set->clearForm 	= array();
		$this->set->notNull 	= array("kd_cabang", "nm_cabang");
		$this->set->grid 		= $this->setGrid();
		$this->set->cetak 		= $this->setPrint();
		$this->set->button 		= array("Save", "First", "Prev", "Next", "Last", "Browse", "Add", "Del", "Edit", "prinT");
		$this->set->addClear 	= true;
		$this->set->notUpper 	= true;
		return $this->set;
	}
	
	protected function setForm()
	{
		// $form[] = array('row' => 25, 'col' => 25, "label" => array("name" => "Sub Group", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kd_sub_cab', "size" => 5, 'after' => 'load("scab", "false", "")')));
		$form[] = array('row' => 0, 'col' => 25, "label" => array("name" => "Kode", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kd_cabang', "size" => 4)));
		$form[] = array('row' => 25, 'col' => 25, "label" => array("name" => "Nama", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'nm_cabang', "size" => 30)));
		$form[] = array('row' => 50, 'col' => 25, "label" => array("name" => "Alamat", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'alamat', "size" => 50)));
		$form[] = array('row' => 75, 'col' => 25, "label" => array("name" => "Kota", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'manager', "size" => 30)));
		
		$form[] = array('row' => 0, 'col' => 500, "label" => array("name" => "Telepon", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'telp', "size" => 25)));
		$form[] = array('row' => 25, 'col' => 500, "label" => array("name" => "Fax", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'fax', "size" => 25)));
		$form[] = array('row' => 50, 'col' => 500, "label" => array("name" => "Email", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'email', "size" => 30)));
		$form[] = array('row' => 75, 'col' => 500, "label" => array("name" => "NPWP", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'npwp', "size" => 25)));
		$form[] = array('row' => 100, 'col' => 500, "label" => array("name" => "Tgl. Pengukuhan", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'tgl_pengukuhan', "size" => 10, 'class' => 'tanggal')));
		$form[] = array('row' => 125, 'col' => 25, "label" => array("name" => "Kop", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kop', "size" => 50)));
		
		$form[] = array('row' => 125, 'col' => 500, "label" => array("name" => "Rek No", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'rek_no', "size" => 20)));
		$form[] = array('row' => 150, 'col' => 500, "label" => array("name" => "A/n", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'rek_an', "size" => 20)));
		$form[] = array('row' => 175, 'col' => 500, "label" => array("name" => "Bank", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'rek_bank', "size" => 20)));
		
		
		
		$form[] = array('row' => 175, 'col' => 25, "label" => array("name" => "By", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'chusr', 'size' => 15, 'readonly' => true)));
		$form[] = array('row' => 200, 'col' => 25, "label" => array("name" => "Last", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'chtime', 'size' => 20, 'readonly' => true)));
		return $form;
	}
	
	protected function setGrid()
	{
		$kode = new Kode;
		$res->page 	= 50;
		$res->sortA = $kode->getPk($this->set->dBasePk);
		$res->sortT = 'asc';
		
		$res->attr[]	= array("label" => 'Sub Group', 'attr' => 'a.kd_sub_cab', "sort" => 'true', "width" => 100, 'align' => 'left', 'focus' => 'true');
		$res->attr[]	= array("label" => 'Kode', 'attr' => 'a.kd_cabang', "sort" => 'true', "width" => 100, 'align' => 'left', 'focus' => 'true');
		$res->attr[]	= array("label" => 'Cabang', 'attr' => 'a.nm_cabang', "sort" => 'true', "width" => 300, 'align' => 'left');
		$res->attr[]	= array("label" => 'Keterangan', 'attr' => 'a.ket', "sort" => 'true', "width" => 200, 'align' => 'left');
		
		return $res;
	}
	
	protected function setPrint()
	{
		$kode = new Kode;
		$res->sortA = $kode->getPk($this->set->dBasePk);
		$res->sortT = 'asc';
		$res->width = '800px';
		
		$res->attr[]	= array("label" => 'Sub Group', 'attr' => 'a.kd_sub_cab', "sort" => 'true', "width" => 40, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Kode', 'attr' => 'a.kd_cabang', "sort" => 'true', "width" => 50, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Cabang', 'attr' => 'a.nm_cabang', "sort" => 'true', 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Keterangan', 'attr' => 'a.ket', "sort" => 'true', "width" => 300, 'align' => 'left', 'filter' => true);
		
		return $res;
	}
	
	public function Index()
	{
		if($_GET['loadAct'] == 'akses'){
			$this->Akses();
			return;
		}
		if($_GET['loadAct'] == 'AksesAct'){
			$this->AksesAct();
			return;
		}
	
		$this->data = $this->set;
		$this->view = "default/index";
	}
	
	public function data()
	{
		$basic = new Basic;
		$this->data = $basic->data($_GET, $this->set);
		$this->view = "default/displayData";
		$this->layout = "view";
	}
	
	public function Find()
	{
		$basic = new Basic;
		$this->data = $basic->find($_GET, $this->set);
		$this->view = "default/displayForm";
		$this->layout = "view";
	}
	
	protected function validasi()
	{
		$basic = new Basic;
		$error[] = $basic->validasiBasic($_POST, $this->set);
		return $basic->getError($error);
	}
	
	public function proses()
	{
		$basic = new Basic;
		$validasi = $this->validasi();
		if($validasi == true){
			$basic->proses($_POST, $this->set, array());
		}
		$this->layout = "null";
	}
	
	public function Delete()
	{
		$basic = new Basic;
		$this->data = $basic->delete($_GET, $this->set);
		$this->layout = "null";
	}
	
	public function cetak()
	{
		$basic = new Basic;
		$this->data->data = $basic->printer($_GET, $this->set);
		$this->data->width = $this->set->cetak->width;
		$this->view = "default/cetak";
		$this->layout = "print";
	}
	
	public function load()
	{
		$basic = new Basic;
		$this->data = $basic->load($_GET, $this->set);
		$this->layout = "null";
	}
	
	public function popUp()
	{
		$basic = new Basic;
		$this->data = $basic->data($_GET, $this->set);
		$this->view = "default/displayDataPopUp";
		$this->layout = "view";
	}
	
	public function cabang()
	{
		$data = $this->em->getFind("cabang", "nm_cabang", array("kd_cabang = '".$_GET['idRef']."'"));
		
		$res->target = $_GET['target'];
		$res->nama 	= $data->nm_cabang;
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function Disdef()
	{
		$field = '*';
		if(!empty($_GET['target'])){
			$field = $_GET['target'];
		}
	
		$data = $this->em->getFind("cabang", $field, array("kd_cabang = '".$_GET['idRef']."'"));
		
		$res->target = $_GET['target'];
		$res->nama 	= $data->$field;
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function loadDisplay()
	{
		$pk = $this->set->dBasePk[0];
		$data = $this->em->getFind($this->set->dBaseH, '*', array("$pk = '".$_GET['idRef']."'"));
		$basic = new Basic;
		$res = $basic->loadDisplay($data, $_GET);
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function Select()
	{
		$data = $this->em->getFindBy($this->set->dBaseH, "kd_cabang as kode, CONCAT(kd_cabang, '___', nm_cabang) as nama", array(), "kd_cabang");
		
		$res->jum 	= count($data);
		$res->data 	= $data;
		$res->div 	= strtoupper($_GET['idDiv']);
		
		echo json_encode($res);
		$this->layout = "null";
	}
}